// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
angular.module('starter', ['ionic', 'starter.controllers', 'starter.services', 'ngCordova', 'ionicProcessSpinner', 'ngCordovaOauth', 'ionicLazyLoad'])

.run(function($ionicPlatform, $rootScope, $window, $state, $cordovaGeolocation, User, Post, Chat, $ionicHistory, $timeout, $cordovaNetwork, MyPusher, PushPermission, Geo, Banner, Purchase) {
  $rootScope.$on("$stateChangeStart", function(event, toState){
    if ($cordovaNetwork.isOnline()){
      if (!MyPusher.state() && $window.localStorage.getItem("id") != null && $window.localStorage.getItem("id") != '') {
        User.subscribeToChannels($window.localStorage.getItem("id"));
      }
    }
    if (!$window.localStorage.getItem("api_key") && toState.name !== 'home' && toState.name !== 'signin' && toState.name !== 'signup1' && toState.name !== 'signup2' && toState.name !== 'forgot_password'){
      event.preventDefault();
      $state.go('home');
      console.log(3)
    }
    else {
      if ($window.localStorage.getItem("api_key") && !$window.localStorage.getItem("gender") && toState.name !== 'forced_update' && toState.name !== 'forgot_password'){
        event.preventDefault();
        $state.go('forced_update');
      }
      if ($window.localStorage.getItem("api_key") && !$window.localStorage.getItem("first_name") && toState.name !== 'forced_update' && toState.name !== 'forgot_password'){
        event.preventDefault();
        $state.go('forced_update');
      }
      if ($window.localStorage.getItem("api_key") && !$window.localStorage.getItem("last_name") && toState.name !== 'forced_update' && toState.name !== 'forgot_password'){
        event.preventDefault();
        $state.go('forced_update');
      }
    }
  });

  $ionicPlatform.ready(function() {

    Purchase.prepare();

    window.ga.startTrackerWithId('UA-65179915-1', 30, function(){}, function(){})

    if(window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);
      cordova.plugins.Keyboard.disableScroll(true);
    }
    if(window.StatusBar) {
      StatusBar.styleDefault();
    }

    document.addEventListener("resume", function() {
      $rootScope.$broadcast('resumeNow');
    }, false);

    // get the current location when loading only once the pop up permission has been
    // asked in a previous session
    if ($window.localStorage.getItem("geo_asked") == 'true') {
      Geo.set()
    }

    // PUSH NOTIFICATION BEGINS
    var notificationOpenedCallback = function(jsonData) {
      console.log(jsonData)
    };
    var notificationReceivedCallback = function(jsonData){
      console.log(jsonData)
    }

    if ($window.localStorage.getItem("permission_alert") == 'true' && $window.localStorage.getItem("asked_permission") == 'true') {
      PushPermission.init()
        .then(function(){
          if (window.plugins.OneSignal){
            window.plugins.OneSignal.getIds(function(response) {
              if (!$window.localStorage.getItem("signalId")) {
                $window.localStorage.setItem("signalId", response.userId)
              }
            });
            // PUSH NOTIFICATION ENDS
          }
        }, function(){})
    }


  //ADMOB
    Banner.prepare();

    document.addEventListener('onAdFailLoad', function(e){
      return;
    });
  })
})

.config(function($stateProvider, $urlRouterProvider, $ionicConfigProvider) {

  $ionicConfigProvider.views.forwardCache(true);
  $ionicConfigProvider.views.maxCache(15);
  $ionicConfigProvider.tabs.position("bottom"); //Places them at the bottom for all OS
  $ionicConfigProvider.tabs.style("standard"); //Makes them all look the same across all OS
  $ionicConfigProvider.navBar.alignTitle("center");
  $ionicConfigProvider.navBar.positionPrimaryButtons("left");

  $stateProvider
    .state('home', {
      cache: false,
      url: '/home',
      templateUrl: 'templates/home.html',
      controller: 'HomeCtrl'
    })

    .state('loading', {
      cache: false,
      url: '/loading',
      templateUrl: 'templates/loading.html',
      controller: 'LoadingCtrl'
    })

    .state('free_days_view', {
      cache: false,
      url: '/free_days_view',
      templateUrl: 'templates/free_days_view.html',
      controller: 'FreeDaysCtrl'
    })

    .state('retry_loading', {
      cache: false,
      url: '/loading',
      templateUrl: 'templates/retry_loading.html',
      controller: 'RetryLoadingCtrl'
    })

    .state('loading_facebook', {
      cache: false,
      url: '/loading_facebook',
      templateUrl: 'templates/loading_facebook.html',
      controller: 'LoadingFacebookCtrl'
    })

    .state('signin', {
      url: '/sign-in',
      templateUrl: 'templates/sign-in.html',
      controller: 'SignInCtrl'
    })

    .state('subscription', {
      url: '/subscription',
      templateUrl: 'templates/subscription.html',
      controller: 'SubscriptionCtrl'
    })

    .state('forgot_password', {
      cache: false,
      url: '/forgot_password',
      templateUrl: 'templates/forgot_password.html',
      controller: 'ForgotPasswordCtrl'
    })

    .state('signup1', {
      url: '/sign-up1',
      templateUrl: 'templates/sign-up1.html',
      controller: 'SignUp1Ctrl'
    })

    .state('signup2', {
      url: '/sign-up2',
      templateUrl: 'templates/sign-up2.html',
      controller: 'SignUp2Ctrl'
    })

    .state('forced_update', {
      url: '/forced_update',
      templateUrl: 'templates/forced_update.html',
      controller: 'ForcedUpdateCtrl'
    })

    .state('permission_for_alerts', {
      url: '/permission_for_alerts',
      templateUrl: 'templates/permission_for_alerts.html',
      controller: 'PermissionForAlertsCtrl'
    })

    .state('tabs.me', {
      url: '/self',
      views: {
        'self-tab': {
          templateUrl: 'templates/self.html',
          controller: 'SelfCtrl'
        }
      }
    })

    .state('tabs.update', {
      cache: false,
      url: '/update',
      views: {
        'self-tab': {
          templateUrl: 'templates/update.html',
          controller: 'UpdateCtrl'
        }
      }
    })

    .state('tabs.who_checked_me', {
      url: '/who_checked_me',
      views: {
        'self-tab': {
          templateUrl: 'templates/who_checked_me.html',
          controller: 'WhoCheckedMeCtrl'
        }
      }
    })

    .state('tabs.post_from_me', {
      cache: false,
      url: '/post_from_me/:id',
      views: {
        'self-tab': {
          templateUrl: 'templates/post_from_me.html',
          controller: 'PostCtrl'
        }
      }
    })

    .state('tabs.profile_from_me', {
      url: '/profile_from_me/:id',
      views: {
        'self-tab': {
          templateUrl: 'templates/profile_from_me.html',
          controller: 'ProfileCtrl'
        }
      }
    })

    .state('tabs.chat_from_me', {
      cache: false,
      url: '/chat_from_me/:other_user_id',
      views: {
        'self-tab': {
          templateUrl: 'templates/chat_from_me.html',
          controller: 'ChatCtrl'
        }
      }
    })

    .state('tabs.inapp_notif_from_self', {
      cache: false,
      url: '/inapp_notif_from_self',
      views: {
        'self-tab': {
          templateUrl: 'templates/inapp_notif_from_self.html',
          controller: 'InAppNotifCtrl'
        }
      }
    })

    .state('tabs', {
      url: '/tab',
      abstract: true,
      templateUrl: 'templates/tabs.html'
    })


    .state('tabs.news', {
      url: '/news',
      views: {
        'news-tab': {
          templateUrl: 'templates/news.html',
          controller: 'NewsCtrl'
        }
      }
    })

    .state('tabs.post_from_news', {
      cache: false,
      url: '/posts_from_news/:id',
      views: {
        'news-tab': {
          templateUrl: 'templates/post_from_news.html',
          controller: 'PostCtrl'
        }
      }
    })

    .state('tabs.profile_from_news', {
      url: '/profile_from_news/:id',
      views: {
        'news-tab': {
          templateUrl: 'templates/profile_from_news.html',
          controller: 'ProfileCtrl'
        }
      }
    })

    .state('tabs.chat_from_news', {
      cache: false,
      url: '/chat_from_news/:other_user_id',
      views: {
        'news-tab': {
          templateUrl: 'templates/chat_from_news.html',
          controller: 'ChatCtrl'
        }
      }
    })

    .state('tabs.inapp_notif_from_news', {
      cache: false,
      url: '/inapp_notif_from_news',
      views: {
        'news-tab': {
          templateUrl: 'templates/inapp_notif_from_news.html',
          controller: 'InAppNotifCtrl'
        }
      }
    })

    .state('tabs.chats', {
      url: '/chats',
      views: {
        'chats-tab': {
          templateUrl: 'templates/chats.html',
          controller: 'ChatsCtrl'
        }
      }
    })

    .state('tabs.chat_from_chats', {
      cache: false,
      url: '/chat_from_chats/:other_user_id',
      views: {
        'chats-tab': {
          templateUrl: 'templates/chat_from_chats.html',
          controller: 'ChatCtrl'
        }
      }
    })

    .state('tabs.request_from_chats', {
      url: '/request_from_chats/:other_user_id',
      views: {
        'chats-tab': {
          templateUrl: 'templates/request_from_chats.html',
          controller: 'RequestCtrl'
        }
      }
    })

    .state('tabs.profile_from_chats', {
      url: '/profile_from_chats/:id',
      views: {
        'chats-tab': {
          templateUrl: 'templates/profile_from_chats.html',
          controller: 'ProfileCtrl'
        }
      }
    })

    .state('tabs.post_from_chats', {
      cache: false,
      url: '/posts_from_chats/:id',
      views: {
        'chats-tab': {
          templateUrl: 'templates/post_from_chats.html',
          controller: 'PostCtrl'
        }
      }
    })

    .state('tabs.inapp_notif_from_chats', {
      cache: false,
      url: '/inapp_notif_from_chats',
      views: {
        'chats-tab': {
          templateUrl: 'templates/inapp_notif_from_chats.html',
          controller: 'InAppNotifCtrl'
        }
      }
    })

    .state('tabs.meet', {
      url: '/meet',
      views: {
        'meet-tab': {
          templateUrl: 'templates/meet.html',
          controller: 'MeetCtrl'
        }
      }
    })

    .state('tabs.profile_from_meet', {
      url: '/profile_from_meet/:id',
      views: {
        'meet-tab': {
          templateUrl: 'templates/profile_from_meet.html',
          controller: 'ProfileCtrl'
        }
      }
    })

    .state('tabs.post_from_meet', {
      cache: false,
      url: '/posts_from_meet/:id',
      views: {
        'meet-tab': {
          templateUrl: 'templates/post_from_meet.html',
          controller: 'PostCtrl'
        }
      }
    })

    .state('tabs.chat_from_meet', {
      cache: false,
      url: '/chat_from_meet/:other_user_id',
      views: {
        'meet-tab': {
          templateUrl: 'templates/chat_from_meet.html',
          controller: 'ChatCtrl'
        }
      }
    })

    .state('tabs.inapp_notif_from_meet', {
      cache: false,
      url: '/inapp_notif_from_meet',
      views: {
        'meet-tab': {
          templateUrl: 'templates/inapp_notif_from_meet.html',
          controller: 'InAppNotifCtrl'
        }
      }
    })


  $urlRouterProvider.otherwise(function($injector) {
      var $state = $injector.get("$state");
      $state.go("loading");
      // $state.go("tabs.meet");
  });

})

.directive("detectFocus", function () {
        return {
            restrict: "A",
            scope: {
                onFocus: '&onFocus',
                onBlur: '&onBlur',
                focusOnBlur: '=focusOnBlur'
            },
            link: function (scope, elem) {

                elem.on("focus", function () {
                    scope.onFocus();
                    scope.focusOnBlur = true;  //note the reassignment here, reason why I set '=' instead of '@' above.
                });

                elem.on("blur", function () {
                    scope.onBlur();
                    if (scope.focusOnBlur)
                        elem[0].focus();
                });
            }
        }
    })

.directive( 'eready', function($parse) {
   return {
       restrict: 'A',
       link: function( $scope, elem, attrs ) {
           elem.bind("load",function(){
              $scope.$apply(function(){
                  var func = $parse(attrs.eready);
                  func($scope);
              })
            })
       }
    }
});
