angular.module('starter.controllers', [])

.controller("baseController", function($rootScope, $state, $scope, $ionicViewSwitcher, $ionicHistory, $window, $stateParams, $cordovaNetwork, $ionicTabsDelegate, $state, User, Chat, InAppNotifications, Loader, MyPusher){
	$scope.chat = Chat;
	$scope.notifs = InAppNotifications;
	$scope.loading = Loader;

	$scope.return = function(tab){
		$backView = $ionicHistory.backView();
		if ($backView){
	    	$backView.go();
		}
		else {
			if (tab === 'meet') {
				tab = "tabs.meet";
			}
			else if (tab === 'news'){
				tab = "tabs.news";
			}
			else if (tab === 'chats'){
				tab = "tabs.chats";
			}
			else if (tab === 'me'){
				tab = "tabs.me";
			}
			$ionicViewSwitcher.nextDirection('back');
			$state.go(tab)
		}
	};

	$scope.goToInApp = function(){
		var tab_number = $ionicTabsDelegate.selectedIndex();
		if (tab_number == 0) {
			$state.go("tabs.inapp_notif_from_meet");
		}
		else if (tab_number == 1){
			$state.go("tabs.inapp_notif_from_news");
		}
		else if (tab_number == 2){
			$state.go("tabs.inapp_notif_from_chats");
		}
		else if (tab_number == 3){
			$state.go("tabs.inapp_notif_from_me");
		}
	}
	$scope.$on('resumeNow', function(event) {
		Chat.all_not_typing(); // cut any 'jumping dots' when coming back from resume, as we might not have received the message saying the other person stopped typing.
		if ($state.current.name == 'tabs.chat_from_chats' || $state.current.name == 'tabs.chat_from_me' || $state.current.name == 'tabs.chat_from_news' || $state.current.name == 'tabs.chat_from_meet'){
			Loader.show_loading();
			Chat.fetch_messages_for_one_chat($stateParams.other_user_id)
				.then(function(){
					Loader.remove_loading();
				}, function(){})
		}
		// $state.current.name
		// if (!MyPusher.state()) {
		// 	alert("no pusher")
		// 	User.subscribeToChannels($window.localStorage.getItem("id"));
		// }
		if (User.others.length == 0){
			$state.go('loading');
		}
		else {
			InAppNotifications.get_index(1)
				.then(function(response){
					User.add_others_not_in_meet(response)
						.then(function(){
							Chat.fetch_index(1)
								.then(function(response){
									User.add_others_not_in_meet(response);
								})
						}, function(){})
				})
		}
	})

	$scope.network = {offline: false};
	$rootScope.$on('$cordovaNetwork:online', function(event, networkState){
		if ($scope.network.offline) {
			if (User.others.length == 0){
				$state.go('loading');
			}
			else {
				InAppNotifications.get_index(1)
					.then(function(response){
						User.add_others_not_in_meet(response)
							.then(function(){
								Chat.fetch_index(1)
									.then(function(response){
										User.add_others_not_in_meet(response)
									}, function(){})
							}, function(){})
					}, function(){})
			}
		}
		$scope.network.offline = false;
	})

	$rootScope.$on('$cordovaNetwork:offline', function(event, networkState){
		$scope.network.offline = true;
	})

})

.controller('HomeCtrl', function($scope, $cordovaOauth, $ionicViewSwitcher, $window, $state, $http, $ionicModal, $q, User, Registration, Banner) {
	var preventLoading = false;
	$scope.inProcessing = false;
	$scope.error = {message: ""};
	$ionicViewSwitcher.nextDirection('none');

	$scope.$on("$ionicView.beforeEnter", function(event, data){
		Banner.hide();
	})
	$ionicModal.fromTemplateUrl('templates/my-fbloading_modal.html', {
	    scope: $scope,
	    animation: 'slide-in-right'
	}).then(function(modal) {
	    $scope.modal = modal;
	}, function(){});

	var fbLoginError = function(error){
		$scope.inProcessing = false;
		$scope.modal.hide();
	};

	var fbLoginSuccess = function(response) {
		if (!response.authResponse || preventLoading){
			return;
		}
		var authResponse = response.authResponse;

		getFacebookProfileInfo(authResponse)
			.then(function(result) {
				var picture = "https://graph.facebook.com/" + authResponse.userID + "/picture?type=square&width=300&height=300";
				var picture_thumbnail = "https://graph.facebook.com/" + authResponse.userID + "/picture?type=square";
          		Registration.sign_in_with_facebook(picture, picture_thumbnail, result)
          			.then(function(){
						      $scope.inProcessing = false;
						      $scope.modal.hide();
						      $state.go('loading');
          			},function(){
						      $scope.inProcessing = false;
						      $scope.modal.hide();
					      	$state.go('loading');
          			})
			}, function(fail){
				$scope.inProcessing = false;
				$scope.modal.hide();
			});
	}

	$scope.stopLoading = function () {
		$scope.modal.hide();
		preventLoading = true;
        $scope.inProcessing = false;
	}

	// This method is to get the user profile info from the facebook api
	var getFacebookProfileInfo = function (authResponse) {
		var info = $q.defer();

		facebookConnectPlugin.api('/me?fields=email,gender,first_name,last_name&access_token=' + authResponse.accessToken, null,
			function (response) {
				info.resolve(response);
			},
			function (response) {
				info.reject(response);
			});
			return info.promise;
	};

	$scope.facebookSignIn = function() {
    $window.localStorage.removeItem("asked_permission");
    $window.localStorage.removeItem("birthday");
    $window.localStorage.removeItem("geo_asked");
    $window.localStorage.removeItem("lat");
    $window.localStorage.removeItem("lon");
    $window.localStorage.removeItem("permission_alert");
    $window.localStorage.removeItem("pusherTransportEncrypted");
    $window.localStorage.removeItem("receipt");
    $window.localStorage.removeItem("show_ads");
    $window.localStorage.removeItem("signalId");
    $window.localStorage.removeItem("transactionId");


		preventLoading = false;
		$scope.isProcessing = true;
    $scope.modal.show();
	    facebookConnectPlugin.getLoginStatus(function(success){
	    	if (preventLoading) {
	    		return;
			}
	    	if(success.status === 'connected'){
				getFacebookProfileInfo(success.authResponse)
					.then(function(result) {
                        if (preventLoading) {
                            return;
                        }
						var picture = "https://graph.facebook.com/" + success.authResponse.userID + "/picture?type=square&width=300&height=300"
						var picture_thumbnail = "https://graph.facebook.com/" + success.authResponse.userID + "/picture?type=square"
		          		Registration.sign_in_with_facebook(picture, picture_thumbnail, result)
		          			.then(function(send_push_permission){
		        				if (send_push_permission == null || $window.localStorage.getItem("asked_permission") != 'true'){
									$scope.inProcessing = false;
									$scope.modal.hide();
									$state.go('permission_for_alerts')
								}
								else {
									$state.go('loading')
								}
		          			},function(){
		          				$scope.inProcessing = false;
								$scope.modal.hide();
		          			})
					}, function(fail){

                        if (preventLoading) {
                            return;
                        }
						$scope.inProcessing = false;
						$scope.modal.hide();
					});
				}
    		else {
				facebookConnectPlugin.login(["email", "public_profile"], fbLoginSuccess, fbLoginError);
    		}
	    })
	}


	$scope.signInFacebook = function(){
      	$cordovaOauth.facebook("848416401858718", ["email", "user_friends"])
      		.then(function(result) {
		        var access_token = result.access_token;
		        var expires_in = result.expires_in;
				$scope.inProcessing = true;
			    $scope.modal.show();
		        $http.get("https://graph.facebook.com/v2.8/me", { params: { access_token: access_token, fields: "email,picture,birthday,gender,interested_in,first_name,last_name", format: "json" }})
		          	.then(function(result) {
		          		Registration.sign_in_with_facebook(result.data)
		          			.then(function(){
								$scope.inProcessing = false;
								$scope.modal.hide();
								$state.go('tabs.meet');
		          			},function(){
		          				$scope.inProcessing = false;
								$scope.modal.hide();
		          			})
		          	})
			}, function(){
				$scope.inProcessing = false;
				$scope.modal.hide();
			})
	}
})

.controller("LoadingCtrl", function($scope, $state, $ionicHistory, $ionicLoading, $window, User, Post, Chat, InAppNotifications, Banner){
	var loadingPrevented = false;
	$ionicHistory.clearHistory();
	$ionicHistory.clearCache();
	$scope.isProcessing = true;
	$scope.$on("$ionicView.beforeEnter", function(event, data){
		Banner.hide();
	});

	$scope.goHome = function () {
        loadingPrevented = true;
        $state.go('home');
	};

	function handleGeneralError() {
		if (loadingPrevented) {
            return;
		}
        $scope.isProcessing = false;
        $state.go('retry_loading');
	}
	User.update_all(1, true)
	  	.then(function(){
	        Post.fetch(1)
	          	.then(function(response){
	          		User.add_others_not_in_meet(response)
	          			.then(function(){
			            	Chat.fetch_index(1)
				            	.then(function(response){
				            		User.add_others_not_in_meet(response)
				            			.then(function(){
						            		InAppNotifications.get_index(1)
						            			.then(function(response){
						            				User.add_others_not_in_meet(response)
							            				.then(function(){
							            					if (loadingPrevented) {
                                      console.log('preventing success handler');
							            						return;
															      }
															      window.ga.setUserId($window.localStorage.getItem("id"));
								            				$scope.isProcessing = false;

                                    $scope.isFirstEnter = $window.localStorage.getItem("isFirstEnter");
								            				if(($scope.isFirstEnter === null || $scope.isFirstEnter == 'true') && $window.localStorage.getItem("is_premium") == 'false'){
                                      $window.localStorage.setItem("isFirstEnter", true);
                                      $state.go('free_days_view');
                                    }else {
                                      $state.go('tabs.meet');
                                    }
							            				}, handleGeneralError)
						            			}, handleGeneralError )
				            			}, handleGeneralError )
				            	}, handleGeneralError )
	          			}, handleGeneralError )
	          	}, handleGeneralError )
	 	}, function(error){

	  		if (loadingPrevented) {
                console.log('preventing last error handler');
	  			return;
			}
	 		if (!$window.localStorage.getItem("api_key")) {
		 		$scope.isProcessing = false;
				$state.go('home');
	 		}
	 		else {
		 		$scope.isProcessing = false;
				$state.go('retry_loading');
	 		}
	 	});

	$scope.$on("$ionicView.afterLeave", function(event, data){
		if ($window.localStorage.getItem("is_premium") && $window.localStorage.getItem("is_premium") == 'false'){
			//Banner.show();
		}
	});
})

.controller('FreeDaysCtrl', function ($scope, $state, $stateParams, $window, Banner, Purchase) {
  $scope.isIOS = ionic.Platform.isIOS();
  $scope.isAndroid = ionic.Platform.isAndroid();
  $scope.purchase = Purchase;
  Banner.hide();
  $window.localStorage.setItem("isFirstEnter", false);

  $scope.closeFreeView = function() {
    if($window.localStorage.getItem("prevStateFree7")){
      $state.go($window.localStorage.getItem("prevStateFree7"));
    }else{
      $state.go('tabs.meet');
    }

  };

  $scope.$on('purchase_done', function(event, args) {
    $state.go('tabs.meet');
  });

  $scope.ad_free_subscription = function(){
    Purchase.paid()
      .then(function(){
      }, function(){})
  };
})

.controller('SignUp1Ctrl', function($scope, $state, Registration, Banner) {
	$scope.user = Registration;
	$scope.isProcessing = false;
	$scope.error = {message: ""};
	$scope.$on("$ionicView.afterEnter", function(event, data){
		window.ga.trackView('Sign Up Screen');
	});

	$scope.signupCompleted = function(){
								$scope.isProcessing = true;
								Registration.email_signup()
									.then(function(){
										$scope.isProcessing = false;
										$state.go('permission_for_alerts');
									}
									,function(response){
										var attribute
										for (var key in response) {
											if (key == "first_name") {
												attribute = 'first name';
											}
											else if (key == "last_name") {
												attribute = 'last name';
											}
											else {
												attribute = key;
											}
											$scope.error.message = $scope.error.message + attribute + " " + response[key][0] + "\n"
										}
										$scope.isProcessing = false;
									})
						}
	$scope.$watch("user.signup", function(newValue, oldValue){
		if ($scope.error.message.length > 0) {
			$scope.error.message = "";
		}
	}, true);
	$scope.$on("$ionicView.afterLeave", function(event, data){
		$scope.error.message = "";
	});
	$scope.$on("$ionicView.beforeEnter", function(event, data){
		Banner.hide();
	});
})

.controller('SignUp2Ctrl', function($scope, $state, Registration) {
	$scope.signupCompleted = function(){
								Registration.email_signup()
									.then(function(){
										$state.go('loading')
									}, function(){})
							}
})

.controller('SignInCtrl', function($scope, $state, $http, $window, $cordovaOauth, Registration, Geo, Banner) {
	$scope.user = { username: '', password: ''};
	$scope.error = { message: "" };

	$scope.$on("$ionicView.afterEnter", function(event, data){
		window.ga.trackView('Sign In Screen');
	});

	$scope.signIn = function(email, password) {
		Registration.login(email, password)
			.then(function(send_push_permission){
				if (send_push_permission == null || $window.localStorage.getItem("asked_permission") != 'true'){
					$state.go('permission_for_alerts')
				}
				else {
					$state.go('loading')
				}
			},
			function(response){
				$scope.error = { message: response.message }
			})
	};
	$scope.$watch("user.username", function(newValue, oldValue){
		if ($scope.error.message.length > 0) {
			$scope.error.message = "";
		}
	});
	$scope.$watch("user.password", function(newValue, oldValue){
		if ($scope.error.message.length > 0) {
			$scope.error.message = "";
		}
	})
	$scope.$on("$ionicView.afterLeave", function(event, data){
		$scope.error.message = "";
	});
	$scope.$on("$ionicView.beforeEnter", function(event, data){
		Banner.hide();
	});
})


.controller('NewsCtrl', function($rootScope, $scope, $timeout, $state, $stateParams, $ionicViewSwitcher, $ionicModal, $ionicHistory, $window, $cordovaCamera, $cordovaFileTransfer, $ionicActionSheet, Post, App, Comment, Like, Loader, User, MyPusher, Interstitial, Banner, Purchase, $ionicPopup, $ionicTabsDelegate) {
	$scope.posts = Post;
	$scope.new_post = {'words': ''};
	$scope.image = {temp: ''};
	$scope.error = {message: ""};
	$scope.isProcessing = false;
	$scope.current_user_id = $window.localStorage.getItem("id");
	$scope.alreadySending = false;
	$scope.user_ads = $window.localStorage.getItem("show_ads") == 'true' ? true : false;
	$scope.which_ads = 1;
	var page = 1;
	Interstitial.prepare();
	$scope.purchase = Purchase;
  $scope.isIOS = ionic.Platform.isIOS();
  $scope.isAndroid = ionic.Platform.isAndroid();
  $scope.myCurrentAvatar = $window.localStorage.getItem("avatar");
  $scope.isUpdateAvatarFirst = true;
  $scope.isPremium = $window.localStorage.getItem("is_premium") == 'true' ? true : false;
  $scope.userCountry = $window.localStorage.getItem("country");

  $scope.newsLiked = false;
  $scope.newsDropdownUnits = [
    {'id':1, 'label': 'All'},
    {'id':2, 'label': 'Liked'}
  ];

  $scope.newsDropdownUnit = $scope.newsDropdownUnits[0];

  $scope.whatBannerShow = function(index, id){
    if( id === 1 ){
      return findBannerIndex($scope.adsBannerNews1, index);
    }
    if( id === 2 ){
      return findBannerIndex($scope.adsBannerNews2, index);
    }
    if( id === 3 ){
      return findBannerIndex($scope.adsBannerNews3, index);
    }
  };

  function findBannerIndex(arr, index){
    if( arr.indexOf(index) >= 0 ){
      return true;
    }else{
      return false;
    }
  }

  $scope.newsDropdownChanged = function (newsDropdownUnit) {
    if(newsDropdownUnit.id === 1){
      $scope.newsLiked = false;
      $scope.newsDropdownUnit = $scope.newsDropdownUnits[0];
    }else if(newsDropdownUnit.id === 2){
      $scope.newsLiked = true;
      $scope.newsDropdownUnit = $scope.newsDropdownUnits[1];
    }
    $scope.doRefresh();
  };

	$scope.$on("$ionicView.beforeEnter", function(event, data){
    $ionicTabsDelegate.showBar(true);
    $scope.isPremium = $window.localStorage.getItem("is_premium") == 'true' ? true : false;
	  if(!$scope.isPremium){
	    $scope.adsBannerNews1 = [];
      $scope.adsBannerNews2 = [];
      $scope.adsBannerNews3 = [];
      var whatBanner = 1;
      var bannerCount = 2;
      for (var s=0; s<500; s++){
        if(whatBanner === 1 && bannerCount === s){
          $scope.adsBannerNews1.push(s);
          whatBanner = 2;
          bannerCount +=6;
        }
        if(whatBanner === 2 && bannerCount === s){
          $scope.adsBannerNews2.push(s);
          whatBanner = 3;
          bannerCount +=6;
        }
        if(whatBanner === 3 && bannerCount === s){
          $scope.adsBannerNews3.push(s);
          whatBanner = 1;
          bannerCount +=6;
        }

      }
    }

		$scope.ads = {show_ads: ($window.localStorage.getItem("show_ads") == 'true' ? true : false)};
    if($scope.isUpdateAvatarFirst || $scope.myCurrentAvatar !== User.current.avatar){
      $scope.isUpdateAvatarFirst = false;
      $scope.myCurrentAvatar = User.current.avatar;
      var pLength = $scope.posts.all.length;
      var pId = parseInt($window.localStorage.getItem("id"));
      for(var i=0; i<pLength; i++){
        var pItem = $scope.posts.all[i].user;
        if(pId === pItem.id){
          $scope.posts.all[i].user.avatar.url = $scope.myCurrentAvatar;
        }
      }
    }
	});

	// reconnect to channel if it is not connected yet
	$scope.$on("$ionicView.afterEnter", function(event, data){
	  if ($window.localStorage.getItem("is_premium") && $window.localStorage.getItem("is_premium") == 'false'){
			Banner.show();
		}
		$scope.which_ads = Math.round(Math.random()*2);
		window.ga.trackView('News Screen');
	});

	$scope.$on("$ionicView.beforeLeave", function(event, data){
		$scope.image.temp = "";
		$cordovaCamera.cleanup(function(){console.log('camera cleaned up')}, function(){})
	});

	$scope.increment_likes = function(post,id){
										if (parseInt($window.localStorage.getItem("id")) == id) {
											return;
										}
										else{
											if (!post.current_user_liked) {
												post.current_user_liked = true;
												post.likes_count = post.likes_count + 1;
												$scope.like(post.id);
											}
										}
									};


	$scope.send_new_comment = function(words, post_id) {
							Comment.create(words, post_id)
						};
	$scope.goToPost = function(id){
							$state.go('tabs.post_from_news', {id: id})
						};
	$scope.doRefresh = function(){

    page = 1;
    Loader.show_loading();
    Post.fetch(1, $scope.newsLiked)
      .then(function(posts){
        User.add_others_not_in_meet(posts)
          .then(function(){
            $scope.$broadcast('scroll.refreshComplete');
            Loader.remove_loading();
          }, function(){
            $scope.$broadcast('scroll.refreshComplete');
            Loader.remove_loading();
          })
      },
      function(){
        Loader.remove_loading();
        $scope.$broadcast('scroll.refreshComplete');
      })
  };

	$scope.loadOlderPosts = function(){
								Loader.show_loading();
								page = page + 1;
								Post.fetch(page, $scope.newsLiked)
									.then(function(){
										if (page == 3 || page == 7 || page == 10) {
											Interstitial.show(2);
											//Interstitial.prepare();
										}
										Loader.remove_loading();
										$scope.$broadcast('scroll.infiniteScrollComplete');
									}, function(){
										Loader.remove_loading();
										$scope.$broadcast('scroll.infiniteScrollComplete');
									})
							};
	$ionicModal.fromTemplateUrl('templates/my-modal.html', {
	    scope: $scope,
	    animation: 'slide-in-up'
	}).then(function(modal) {
	    $scope.modal = modal;

		$scope.open_modal = function() {
      $cordovaCamera.cleanup(function(){console.log('camera cleaned up')}, function(){});
      $scope.image.temp = "";
      Interstitial.prepare();
      Loader.remove_loading();
      $scope.modal.show();
    };

		$scope.close_modal = function(){
      Interstitial.prepare();
      $cordovaCamera.cleanup(function(){console.log('camera cleaned up')}, function(){});
      $scope.new_post = {'words': ''};
      $scope.image.temp = '';
      $scope.error.message = "";
      $scope.modal.hide();
    }
	}, function(){});
	$scope.chooseCameraType = function() {
		$ionicActionSheet.show({
			buttons: [
				{ text: 'Take a picture' },
				{ text: 'Choose from gallery' }
			],
			titleText: '',
			cancelText: 'Cancel',
			buttonClicked: function(index) {
				if (index == 0){
				  takePicture('camera');
				  return true
				}
				else{
				  takePicture('gallery');
				  return true
				}
			}
		});
	};
	takePicture = function(type){
		if (type == 'camera') {
			sourceType = Camera.PictureSourceType.CAMERA;
		}
		else {
			sourceType = Camera.PictureSourceType.PHOTOLIBRARY;
		}
		var options = {
			destinationType: Camera.DestinationType.FILE_URI,
			sourceType: sourceType,
			encodingType: 1,
			cameraDirection: 1,
			quality: 20,
			targetWidth: 400,
			targetHeight: 400
		};
		$cordovaCamera.getPicture(options)
      .then(function(imageURI) {
        $scope.image.temp = '';
				$scope.image.temp = imageURI + '?' + new Date().getTime();
			}, function(){})
	};

	$scope.send_new_post = function(words) {
							$scope.alreadySending = true;
							$scope.isProcessing = true;
							if ($scope.image.temp.length > 0){
								if (words.length == 0) {
									$scope.isProcessing = false;
									$scope.error.message = "You should write something";
									$scope.alreadySending = false;
								} else {
									$scope.error.message = "";
                  var server = App.url + App.version + "/posts";
                  var filePath = $scope.image.temp;

							        var file_options = {
							                              "params":{
							                                "api_key": $window.localStorage.getItem("api_key"),
							                                "key": App.key,
							                                "words": words
							                              }
							                            };
							        $cordovaFileTransfer.upload(server, filePath, file_options)
							          	.then(function(result) {
							          		$scope.isProcessing = false;
							            	data = JSON.parse(result.response);
							            	Post.create_with_picture(data)
							            		.then(function(){
							            			$scope.modal.hide();
                                $scope.new_post = {'words': ''};
                                $scope.image.temp = "";
                                $scope.error.message = "";
                                $scope.isProcessing = false;
                                $scope.alreadySending = false;
                                Interstitial.show(3);
                                $cordovaCamera.cleanup(function(){console.log('camera cleaned up')}, function(){});
                                //Interstitial.prepare();
							            		}, function(){})
                          }, function(err) {
                            $scope.error.message = "There was a problem. Try again!";
                            $scope.new_post = {'words': ''};
                            $scope.image.temp = "";
                            $scope.error.message = "";
                            $scope.isProcessing = false;
                            $scope.alreadySending = false;
                            })
   							    }
							} else {
								if (words.length > 0) {
									$scope.isProcessing = true;
									Post.create(words)
										.then(function(){
											$scope.isProcessing = false;
											$scope.modal.hide();
											$scope.new_post = {'words': ''};
											$scope.error.message = "";
											$scope.alreadySending = false;
											Interstitial.show(3);
											//Interstitial.prepare();
										}, function(error){
											$scope.error.message = error.message.words[0];
		        							$scope.isProcessing = false;
		        							$scope.alreadySending = false;
										})
								}
								else {
									$scope.alreadySending = false;
									$scope.isProcessing = false;
								}
							}
						};
	$scope.like = function(id) {
					Like.post(id)
						.then(function(){
							$rootScope.apply;
						}, function(){})
				};

	$scope.$on('purchase_done', function(event, args) {
		console.log('purchase done broadcasted');
		$scope.ads = { show_ads: false };
    $scope.isPremium = true;
	});


	$ionicModal.fromTemplateUrl('templates/subscription_modal.html', {
		scope: $scope,
		animation: 'slide-in-up'
		}).then(function(subscription_modal) {
			$scope.subscription_modal = subscription_modal;
		}
	);

	$scope.openSubscriptionModal = function() {
	  if(!$window.localStorage.getItem("checkFree7ShownTime")){
      $window.localStorage.setItem("checkFree7ShownTime", new Date().getTime());
      $window.localStorage.setItem("prevStateFree7", 'tabs.news');
      $state.go('free_days_view');
      return;
    }
    var pTimeFree = $window.localStorage.getItem("checkFree7ShownTime");
    if(pTimeFree){
	    if(((new Date().getTime() - Number(pTimeFree)) / 3600000) > 24){
        $window.localStorage.setItem("checkFree7ShownTime", new Date().getTime());
        $window.localStorage.setItem("prevStateFree7", 'tabs.news');
        $state.go('free_days_view');
        return;
      }
    }
      $scope.subscription_modal.show();
      Banner.hide();

  };

	$scope.closeSubscriptionModal = function() {
									Banner.show();
									$scope.subscription_modal.hide();
								};

	$ionicModal.fromTemplateUrl('templates/subscription_details_modal.html', {
		scope: $scope,
		animation: 'slide-in-up'
		}).then(function(subscription_details_modal) {
			$scope.subscription_details_modal = subscription_details_modal;
		}
	);

	$scope.openSubscriptionDetailsModal = function() {
    $scope.subscription_details_modal.show();
  };

	$scope.closeSubscriptionDetailsModal = function() {
    $scope.subscription_details_modal.hide();
  };

	//

  $ionicModal.fromTemplateUrl('templates/privacy_policy.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(privacy_policy_modal) {
      $scope.privacy_policy_modal = privacy_policy_modal;
    }
  );

  $scope.openPrivacyPolicyModal = function() {
    $scope.privacy_policy_modal.show();
  };

  $scope.closePrivacyPolicyModal = function() {
    $scope.privacy_policy_modal.hide();
  };

  $ionicModal.fromTemplateUrl('templates/terms_of_use.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(terms_of_use_modal) {
      $scope.terms_of_use_modal = terms_of_use_modal;
    }
  );

  $scope.openTermsOfUseModal = function() {
    $scope.terms_of_use_modal.show();
  };

  $scope.closeTermsOfUseModal = function() {
    $scope.terms_of_use_modal.hide();
  };

	$scope.$on('purchase_done', function(event, args) {
		$scope.ads = { show_ads: false };
    $scope.isPremium = true;
		$scope.subscription_modal.hide();
		$scope.subscription_details_modal.hide();
	});


	$scope.ad_free_subscription = function(){
    Purchase.paid()
      .then(function(){
      }, function(){})
  };

	$scope.stateGoPostFromNews = function (id) {
    $state.go('tabs.post_from_news',{id: id});
  };

  $scope.show_popup_remove_post = function (event, post){
    event.stopPropagation();
    if (parseInt($window.localStorage.getItem("id")) === post.user.id) {
      $ionicActionSheet.show({
        titleText: '',
        destructiveText: 'Delete post',
        cancelText: 'Cancel',
        destructiveButtonClicked: function() {

            var confirmPopup = $ionicPopup.confirm({
              title: 'Delete',
              template: 'Are you sure you want to delete this post?',
              cancelText: 'No',
              okText: 'Yes'
            });

            confirmPopup.then(function(res) {
              if(res) {
                Post.deletePost(post.id)
                  .then(function () {
                      User.self_update();
                  },
                  function () {
                  })
              }
            });
            return true
          }

      });
    }else {
      $ionicActionSheet.show({
        buttons: [
          { text: 'Report this user' },
          { text: 'Block this user' }
        ],
        titleText: '',
        cancelText: 'Cancel',
        buttonClicked: function(index) {
          if (index == 0){
            var confirmPopup = $ionicPopup.confirm({
              title: 'Report',
              template: 'Are you sure you want to report this user?',
              cancelText: 'No',
              okText: 'Yes'
            });

            confirmPopup.then(function(res) {
              if(res) {
                User.report_user(post.user.id)
              }
            });
            return true
          } else {
            var confirmPopup = $ionicPopup.confirm({
              title: 'Block',
              template: 'Are you sure you want to block this user?',
              cancelText: 'No',
              okText: 'Yes'
            });

            confirmPopup.then(function(res) {
              if(res) {
                User.block_user(post.user.id)
                  .then(function(){
                    $scope.blocked_user = true;
                    User.update_all(1, false);
                  }, function(){
                    $scope.blocked_user = true;
                  })
              }
            });
            return true
          }
        }
      });
    }
  }

})

.controller('PostCtrl', function($rootScope, $scope, $window, $stateParams, $state, $ionicScrollDelegate, $timeout, $ionicPopup, $ionicHistory, Post, Comment, Like, User, Loader) {
	$scope.post = {};
	Loader.show_loading();
	$scope.alreadySending = false;
  $scope.user = User;

	$scope.$on("$ionicView.afterEnter", function(event, data){
	  window.ga.trackView('Single News Screen');
	});

	Post.find($stateParams.id)
		.then(function(post){
			$scope.post = post;
			Post.fetch_comments($stateParams.id)
				.then(function(response){
					Loader.remove_loading();
					User.add_others_not_in_meet(response);
				}, function(status){
					if (status === 404) {
						Post.remove($stateParams.id)
							.then(function(){
								$ionicPopup.alert({
									title: 'Oops',
									template: 'This news does not exist anymore!'
								}).then(function(res) {
									$backView = $ionicHistory.backView();
									if ($backView){
								    	$backView.go();
									}
								}, function(){});
							})
					}
					Loader.remove_loading();
				})
		},function(){
			Loader.remove_loading();
		})

	$scope.increment_likes = function(post, id){
										if (parseInt($window.localStorage.getItem("id")) == id) {
											return;
										}
										else{
											if (!post.current_user_liked) {
												post.current_user_liked = true;
												post.likes_count = post.likes_count + 1;
												$scope.like(post.id);
											}
										}
									}

	$scope.like = function(id) {
					Like.post(id)
						.then(function(){
							$rootScope.apply;
						}, function(){})
				};

	$scope.new_comment = {'words': ''};
	$scope.send_new_comment = function(words) {
									if (words.length > 0 ){
										$scope.alreadySending = true;
										Loader.show_loading();
										$scope.new_comment = {'words': ''};
										Comment.create(words, $stateParams.id)
											.then(function(){
												$scope.alreadySending = false;
												Loader.remove_loading();
												$rootScope.apply;
											}, function(status){
												if (status === 404) {
													Post.remove($stateParams.id)
														.then(function(){
															$ionicPopup.alert({
																title: 'Oops',
																template: 'This news does not exist anymore!'
															}).then(function(res) {
																$backView = $ionicHistory.backView();
																if ($backView){
															    	$backView.go();
																}
															}, function(){});
														}, function(){})
												}
												Loader.remove_loading();
												$scope.alreadySending = false;
											})
									}
								};

	$scope.focus_comment_input = function(){
    //$ionicTabsDelegate.showBar(false);
									$timeout(function() {
										$ionicScrollDelegate.scrollBottom(true);
									}, 300);
								}
})

.controller('SelfCtrl', function($scope, $rootScope, $state, $window, User, $ionicViewSwitcher, $ionicHistory, MyPusher, $ionicModal, $timeout, Banner, Purchase, Loader) {
	$scope.screenwidth = $window.innerWidth * 0.8;
	$timeout(function(){$ionicViewSwitcher.nextDirection('forward');});
	$scope.user = User;
	$scope.show_ads = false;
	$scope.purchase = Purchase;
  $scope.isIOS = ionic.Platform.isIOS();
  $scope.isAndroid = ionic.Platform.isAndroid();
  $scope.isPremium = $window.localStorage.getItem("is_premium") == 'true' ? true : false;

	// $scope.current_user = {
	// 					avatar: $window.localStorage.getItem("avatar"),
	// 					username: $window.localStorage.getItem("username"),
	// 					first_name: $window.localStorage.getItem("first_name"),
	// 					last_name: $window.localStorage.getItem("last_name"),
	// 					birthday: $window.localStorage.getItem("birthday"),
	// 					gender: $window.localStorage.getItem("gender"),
	// 					interested_in: $window.localStorage.getItem("interested_in"),
	// 					city: $window.localStorage.getItem("city"),
	// 					country: $window.localStorage.getItem("country"),
	// 					age: $window.localStorage.getItem("age")
	// 				}

	$scope.$on("$ionicView.beforeEnter", function(event, data){
		$scope.ads = {show_ads: ($window.localStorage.getItem("show_ads") == 'true' ? true : false)};
    $scope.isPremium = $window.localStorage.getItem("is_premium") == 'true' ? true : false;
	});

	// reconnect to channel if it is not connected yet
	$scope.$on("$ionicView.afterEnter", function(event, data){
		$scope.show_ads = $window.localStorage.getItem("show_ads");
		if ($window.localStorage.getItem("is_premium") && $window.localStorage.getItem("is_premium") == 'false'){
			Banner.show();
		}
		window.ga.trackView('Me Screen');
	});

	$scope.isProcessing = true;
	User.show_news_from_user($window.localStorage.getItem("id"))
		.then(function(response){
			$scope.isProcessing = false;
			$scope.user.posts = response.data.posts;
			Loader.remove_loading();
			$rootScope.apply;
		}, function(){
			Loader.remove_loading();
		});

	$scope.whoCheckedMe = function () {
    if($scope.ads.show_ads || !$scope.isPremium){
      $scope.openSubscriptionModal();
    }else{
      $state.go('tabs.who_checked_me');
    }
  };

	$scope.logOut = function(){
						User.logout()
							.then(function(){
								$window.localStorage.removeItem("id");
								$window.localStorage.removeItem("username");
								$window.localStorage.removeItem("api_key");
								$window.localStorage.removeItem("avatar");
								$window.localStorage.removeItem("first_name");
								$window.localStorage.removeItem("last_name");
								$window.localStorage.removeItem("gender");
								$window.localStorage.removeItem("interested_in");
								$window.localStorage.removeItem("age");
								$window.localStorage.removeItem("city");
								$window.localStorage.removeItem("country");
								$window.localStorage.removeItem("bio");
								$ionicHistory.clearCache();
								$ionicHistory.clearHistory();
								$ionicHistory.removeBackView();
								$ionicHistory.nextViewOptions({
								  disableAnimate: true,
								  disableBack: true
								});
								$state.go('home', {reload:true});
							}, function(){})
					};

	$scope.show_username = function(first_name, last_name, username){
								if (!first_name && !last_name){
									return username;
								}
								else if (first_name == null && last_name == null){
									return username;
								}
								else if (first_name == 'null' && last_name == 'null'){
									return username;
								}
							};

	$scope.show_name = function(name){
								if (name && name !== null && name !== 'null') {
									return name;
								}
							};

	$scope.doRefresh = function(){
						User.self_update()
							.then(function(){
								$scope.$broadcast('scroll.refreshComplete');
							}, function(){})
	};

	$ionicModal.fromTemplateUrl('templates/subscription_modal.html', {
		scope: $scope,
		animation: 'slide-in-up'
		}).then(function(subscription_modal) {
			$scope.subscription_modal = subscription_modal;
		}
	);

  $scope.openSubscriptionModal = function() {
    if(!$window.localStorage.getItem("checkFree7ShownTime")){
      $window.localStorage.setItem("checkFree7ShownTime", new Date().getTime());
      $window.localStorage.setItem("prevStateFree7", 'tabs.me');
      $state.go('free_days_view');
      return;
    }
    var pTimeFree = $window.localStorage.getItem("checkFree7ShownTime");
    if(pTimeFree){
      if(((new Date().getTime() - Number(pTimeFree)) / 3600000) > 24){
        $window.localStorage.setItem("checkFree7ShownTime", new Date().getTime());
        $window.localStorage.setItem("prevStateFree7", 'tabs.me');
        $state.go('free_days_view');
        return;
      }
    }
    $scope.subscription_modal.show();
    Banner.hide();

  };

	$scope.closeSubscriptionModal = function() {
									Banner.show();
									$scope.subscription_modal.hide();
								};

	$ionicModal.fromTemplateUrl('templates/subscription_details_modal.html', {
		scope: $scope,
		animation: 'slide-in-up'
		}).then(function(subscription_details_modal) {
			$scope.subscription_details_modal = subscription_details_modal;
		}
	);

	$scope.openSubscriptionDetailsModal = function() {
    $scope.subscription_details_modal.show();
  };

	$scope.closeSubscriptionDetailsModal = function() {
    $scope.subscription_details_modal.hide();
  };

  //

  $ionicModal.fromTemplateUrl('templates/privacy_policy.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(privacy_policy_modal) {
      $scope.privacy_policy_modal = privacy_policy_modal;
    }
  );

  $scope.openPrivacyPolicyModal = function() {
    $scope.privacy_policy_modal.show();
  };

  $scope.closePrivacyPolicyModal = function() {
    $scope.privacy_policy_modal.hide();
  };

  $ionicModal.fromTemplateUrl('templates/terms_of_use.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(terms_of_use_modal) {
      $scope.terms_of_use_modal = terms_of_use_modal;
    }
  );

  $scope.openTermsOfUseModal = function() {
    $scope.terms_of_use_modal.show();
  };

  $scope.closeTermsOfUseModal = function() {
    $scope.terms_of_use_modal.hide();
  };

	$scope.$on('purchase_done', function(event, args) {
		$scope.ads = { show_ads: false };
    $scope.isPremium = true;
		$scope.subscription_modal.hide();
		$scope.subscription_details_modal.hide();
	});


	$scope.ad_free_subscription = function(){
									Purchase.paid()
										.then(function(){
										}, function(){})
								}
})

.controller('MeetCtrl', function($scope, $rootScope, $window, $timeout, $ionicViewSwitcher, $state, $ionicModal, User, Loader, MyPusher, Interstitial, Geo, Banner, Purchase, $ionicTabsDelegate) {
	$scope.user = User;
	var page = 1;
	$scope.show_ads = false;
	Interstitial.prepare();
	$scope.purchase = Purchase;
	$scope.isIOS = ionic.Platform.isIOS();
	$scope.isAndroid = ionic.Platform.isAndroid();
  $scope.isPremium = $window.localStorage.getItem("is_premium") == 'true' ? true : false;
  $scope.userCountry = $window.localStorage.getItem("country");

  $scope.$on("$ionicView.beforeEnter", function(event, data){
    $ionicTabsDelegate.showBar(true);
    $scope.isPremium = $window.localStorage.getItem("is_premium") == 'true' ? true : false;
  });

	// be sure the banner shows
	$scope.$on("$ionicView.afterEnter", function(event, data){
		$scope.ads = {show_ads: ($window.localStorage.getItem("show_ads") == 'true' ? true : false)}
		if ($window.localStorage.getItem("is_premium") && $window.localStorage.getItem("is_premium") == 'false'){
			Banner.show();
		}
		window.ga.trackView('Meet Screen');
	});

	$scope.$on("$ionicView.beforeLeave", function(event, data){
		if ($window.localStorage.getItem("geo_asked") != 'true') {
			Geo.set()
				.then(function(){
					User.set_geo_first_time()
				}, function(){})
		}
	});

	$scope.isLoaded = function(index){
		if (index === 19) {
			$scope.show_ads = true;
		}
	};



	$scope.widthinPX = $window.innerWidth;
	$scope.doRefresh = function(){
							Loader.show_loading();
						    User.update_all(1, false)
								.then(function(){
									Loader.remove_loading();
									$scope.$broadcast('scroll.refreshComplete');
								}, function(){
									$scope.$broadcast('scroll.refreshComplete');
								})
						};
	$scope.loadMore = function(){
							if (page == 2 || page == 5 || page == 9) {
								Interstitial.show(1);
								//Interstitial.prepare();
							}
							if (page < 8) {
							    User.update_all(page + 1, false)
									.then(function(){
										page = page + 1;
										$scope.$broadcast('scroll.infiniteScrollComplete');
									}, function(){
										$scope.$broadcast('scroll.infiniteScrollComplete');
									})
							}
							else {
								$scope.$broadcast('scroll.infiniteScrollComplete');
							}
						};

	$ionicModal.fromTemplateUrl('templates/subscription_modal.html', {
		scope: $scope,
		animation: 'slide-in-up'
		}).then(function(subscription_modal) {
			$scope.subscription_modal = subscription_modal;
		}
	);

  $scope.openSubscriptionModal = function() {
    if(!$window.localStorage.getItem("checkFree7ShownTime")){
      $window.localStorage.setItem("checkFree7ShownTime", new Date().getTime());
      $window.localStorage.setItem("prevStateFree7", 'tabs.meet');
      $state.go('free_days_view');
      return;
    }
    var pTimeFree = $window.localStorage.getItem("checkFree7ShownTime");
    if(pTimeFree){
      if(((new Date().getTime() - Number(pTimeFree)) / 3600000) > 24){
        $window.localStorage.setItem("checkFree7ShownTime", new Date().getTime());
        $window.localStorage.setItem("prevStateFree7", 'tabs.meet');
        $state.go('free_days_view');
        return;
      }
    }
    $scope.subscription_modal.show();
    Banner.hide();

  };

	$scope.closeSubscriptionModal = function() {
									Banner.show();
									$scope.subscription_modal.hide();
								};

	$ionicModal.fromTemplateUrl('templates/subscription_details_modal.html', {
		scope: $scope,
		animation: 'slide-in-up'
		}).then(function(subscription_details_modal) {
			$scope.subscription_details_modal = subscription_details_modal;
		}
	);

	$scope.openSubscriptionDetailsModal = function() {
									$scope.subscription_details_modal.show();
								};

	$scope.closeSubscriptionDetailsModal = function() {
									$scope.subscription_details_modal.hide();
								};

  //

  $ionicModal.fromTemplateUrl('templates/privacy_policy.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(privacy_policy_modal) {
      $scope.privacy_policy_modal = privacy_policy_modal;
    }
  );

  $scope.openPrivacyPolicyModal = function() {
    $scope.privacy_policy_modal.show();
  };

  $scope.closePrivacyPolicyModal = function() {
    $scope.privacy_policy_modal.hide();
  };

  $ionicModal.fromTemplateUrl('templates/terms_of_use.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(terms_of_use_modal) {
      $scope.terms_of_use_modal = terms_of_use_modal;
    }
  );

  $scope.openTermsOfUseModal = function() {
    $scope.terms_of_use_modal.show();
  };

  $scope.closeTermsOfUseModal = function() {
    $scope.terms_of_use_modal.hide();
  };

	$scope.$on('purchase_done', function(event, args) {
		$scope.ads = { show_ads: false };
    $scope.isPremium = true;
		$scope.subscription_modal.hide();
		$scope.subscription_details_modal.hide();
	});


	$scope.ad_free_subscription = function(){
									Purchase.paid()
										.then(function(){
										}, function(){})
								}
})

.controller("ProfileCtrl", function($rootScope, $scope, $window, $ionicViewSwitcher, $ionicHistory, $state, $stateParams, $ionicActionSheet, $ionicPopup, User, App, Chat, Like, Loader, $ionicTabsDelegate){
	$scope.isSearchingProfile = true;
	$scope.isProcessing = false;
	$scope.param = $stateParams.id;
	$scope.screenwidth = $window.innerWidth;
	$scope.is_current_user = false;
	$scope.blocked_user = false;
  $scope.isPremium = $window.localStorage.getItem("is_premium") == 'true' ? true : false;

	$scope.$on("$ionicView.beforeEnter", function(event, data){
    $ionicTabsDelegate.showBar(true);
    window.ga.trackView('Profile Screen');
		if (User.blocked_users.indexOf($stateParams.id) != -1) {
			$scope.blocked_user = true;
		}
		else if ($stateParams.id == $window.localStorage.getItem("id")){
			$scope.blocked_user = true;
			$scope.currentUserAvatar = User.current.avatar;
		}
	});

	if ($stateParams.id == $window.localStorage.getItem("id")){
		$scope.is_current_user = true;
	}
	Loader.show_loading();
	User.find($stateParams.id)
		.then(function(response){
			$scope.isSearchingProfile = false;
			$scope.isProcessing = true;
			$scope.user = response;
			User.show_news_from_user($stateParams.id)
				.then(function(response){
					$scope.isProcessing = false;
					$scope.user = response.data;
					Loader.remove_loading();
					$rootScope.apply;
				}, function(){
					Loader.remove_loading();
				})
		},
		function(status){
			if (status === 404) {
				$ionicPopup.alert({
					title: 'Oops',
					template: 'This user does not exist anymore!'
				}).then(function(res) {
					$backView = $ionicHistory.backView();
					if ($backView){
				    	$backView.go();
					}
				}, function(){});
			}
			Loader.remove_loading();
		});

	$scope.checkLimitContacts = function (obj, navigateTo) {
	  if(!$scope.isPremium){
      var chatContactsLength = Chat.all.length;
      var isChatNow = false;
      for(var i=0; i < chatContactsLength; i++){
        if(obj.other_user_id == Chat.all[i].other_user_id){
          isChatNow = true;
          break;
        }
      }
      if(chatContactsLength == 3 && !isChatNow){
        $ionicPopup.alert({
          title: 'Oops',
          template: 'Upgrade to Natter+ to have more natters (or delete an existing one)'
        });
      } else if(chatContactsLength > 3 && !isChatNow){
        $ionicPopup.alert({
          title: 'Oops',
          template: 'Upgrade to Natter+ to have more natters (or delete some - 3 free is the maximum)'
        });
      } else{
        $state.go('tabs.'+navigateTo, obj);
      }
    }else{
      $state.go('tabs.'+navigateTo, obj);
    }

  };

	$scope.increment_post_likes = function(post, id){
										if ($scope.blocked_user){
											return;
										}
										if (parseInt($window.localStorage.getItem("id")) == id) {
											return;
										}
										else {
											if (!post.current_user_liked) {
												post.current_user_liked = true;
												post.likes_count = post.likes_count + 1;
												$scope.like_post(post.id);
											}
										}
									}

	$scope.like_post = function(id) {
					Like.post(id)
						.then(function(){
							$rootScope.apply;
						}, function(){})
				};

	$scope.increment_picture_likes = function(picture, id){
										if ($scope.blocked_user){
											return;
										}
										if (parseInt($window.localStorage.getItem("id")) == id) {
											return;
										}
										else{
											if (!picture.current_user_liked) {
												picture.current_user_liked = true;
												picture.likes_count = picture.likes_count + 1;
												$scope.like_picture(picture.id);
											}else{
                        picture.current_user_liked = false;
                        picture.likes_count = picture.likes_count - 1;
                        $scope.like_picture(picture.id);
                      }
										}
									};

	$scope.like_picture = function(id) {
					Like.picture(id)
						.then(function(){
							$rootScope.apply;
						}, function(){})
				};

	$scope.more = function(){
						$ionicActionSheet.show({
							buttons: [
								{ text: 'Report this user' },
								{ text: 'Block this user' }
							],
							titleText: '',
							cancelText: 'Cancel',
							buttonClicked: function(index) {
								if (index == 0){
									var confirmPopup = $ionicPopup.confirm({
														    title: 'Report',
														    template: 'Are you sure you want to report this user?',
														    cancelText: 'No',
  															okText: 'Yes'
									   					});

									   	confirmPopup.then(function(res) {
									     	if(res) {
									       		User.report_user($stateParams.id)
									     	} else {
									     	}
									   	});
									// User.report_user($stateParams.id)
									// var alertPopup = $ionicPopup.alert({
									// 	title: 'Thank you',
									// 	template: 'This user has been reported'
									// });
									// alertPopup.then(function(res) {
									// }, function(){});
									return true
								}
								else {
									var confirmPopup = $ionicPopup.confirm({
														    title: 'Block',
														    template: 'Are you sure you want to block this user?',
														    cancelText: 'No',
  															okText: 'Yes'
									   					});

									   	confirmPopup.then(function(res) {
									     	if(res) {
									       		User.block_user($stateParams.id)
													.then(function(){
														$scope.blocked_user = true;
													}, function(){
														$scope.blocked_user = true;
													})
													if ($state.current.name == 'tabs.profile_from_chats') {
														$state.go('tabs.chats')
													}
													else if ($state.current.name == 'tabs.profile_from_news'){
														$state.go('tabs.news')
													}
													else {
														$backView = $ionicHistory.backView();
														if ($backView){
													    	$backView.go();
														}
													}
									     	}
									     })

									// User.block_user($stateParams.id)
									// 	.then(function(){
									// 		$scope.blocked_user = true;
									// 	}, function(){
									// 		$scope.blocked_user = true;
									// 	})
									// var alertPopup = $ionicPopup.alert({
									// 	title: '',
									// 	template: 'This user is now blocked'
									// });
									// alertPopup.then(function(res) {
									// 	if ($state.current.name == 'tabs.profile_from_chats') {
									// 		$state.go('tabs.chats')
									// 	}
									// 	else if ($state.current.name == 'tabs.profile_from_news'){
									// 		$state.go('tabs.news')
									// 	}
									// 	else {
									// 		$backView = $ionicHistory.backView();
									// 		if ($backView){
									// 	    	$backView.go();
									// 		}
									// 	}
									// }, function(){});
									return true
								}
							}
						});
					}
	$scope.unblock = function(){
						User.unblock_user($stateParams.id)
							.then(function(){
								$scope.blocked_user = false;
							}, function(){
								$scope.blocked_user = false;
							})
					}
})

.controller('UpdateCtrl', function($rootScope, $scope, $state, $ionicActionSheet, $ionicViewSwitcher, $window, $cordovaCamera, $cordovaFileTransfer, App, Registration, User, Post) {
	$scope.isProcessing = false;
	$scope.isAvatarProcessing = false;
	$scope.error_present = false;
	$scope.errors = {message: []};

	$scope.$on("$ionicView.afterEnter", function () {
		window.ga.trackView('Update Screen');
	})

	$scope.user = {
						first_name: $window.localStorage.getItem("first_name"),
						last_name: $window.localStorage.getItem("last_name"),
						username: !$window.localStorage.getItem("username") ? "" : $window.localStorage.getItem("username"),
						birthday: !$window.localStorage.getItem("birthday") ? "" : new Date($window.localStorage.getItem("birthday")),
						gender: $window.localStorage.getItem("gender"),
						interested_in: $window.localStorage.getItem("interested_in"),
						bio: $window.localStorage.getItem("bio")
					}
	$scope.avatar = $window.localStorage.getItem("avatar");

	$scope.$on("$ionicView.beforeLeave", function () {
		$cordovaCamera.cleanup(function(){console.log('camera cleaned up')}, function(){})
	});

	$scope.update = function(user){
						$scope.error_present = false;
						$scope.isProcessing = true;
						Registration.update(user)
							.then(function(){
                  User.update_all(1, false)
                    .then(function(){

                      Post.fetch(1)
                        .then(function(){
                          $scope.isProcessing = false;
                          $rootScope.apply;
                          $state.go('tabs.me')
                        }, function(){
                          $scope.isProcessing = false;
                          $rootScope.apply;
                          $state.go('tabs.me')
                        })


                    }, function(){});

							},
							function(reject_message){
								$scope.errors = {message: []};
								$scope.error_present = true;
								for (var prop in reject_message) {
									$scope.errors.message.push("this " + prop + " " + reject_message[prop])
								}
								$scope.isProcessing = false;
							})
					}
	$scope.changeAvatar = function(){
							$ionicActionSheet.show({
								buttons: [
									{ text: 'Take a picture' },
									{ text: 'Choose from gallery' }
								],
								titleText: 'Change your avatar?',
								cancelText: 'Cancel',
								buttonClicked: function(index) {
									if (index == 0){
									  takePicture('camera');
									  return true
									}
									else{
									  takePicture('gallery');
									  return true
									}
								}
							});
	}
	takePicture = function(type){
		if (type == 'camera') {
			sourceType = Camera.PictureSourceType.CAMERA;
		}
		else {
			sourceType = Camera.PictureSourceType.PHOTOLIBRARY;
		}
		var options = {
			destinationType: Camera.DestinationType.FILE_URI,
			sourceType: sourceType,
			encodingType: 1,
			cameraDirection: 1,
			quality: 40,
			targetWidth: 500,
			targetHeight: 500
		};
		$cordovaCamera.getPicture(options)
      		.then(function(imageURI) {
      			$scope.isAvatarProcessing = true;
				if (imageURI.length > 0){
			        var server = App.url + App.version + "/update_avatar";
			        var filePath = imageURI;
			        var file_options = {
			                              "params":{
			                                "api_key": $window.localStorage.getItem("api_key"),
			                                "key": App.key
			                              }
			                            };
			        $cordovaFileTransfer.upload(server, filePath, file_options)
			          	.then(function(result) {
			            	data = JSON.parse(result.response)
			            	$scope.avatar = data.avatar;
			            	$window.localStorage.setItem("avatar",data.avatar);
			            	User.current.avatar = data.avatar;
			            	$rootScope.apply;
			            	$scope.isAvatarProcessing = false;
			            	$state.go('tabs.me')
						})
				}
			}, function(){})
	}
})

.controller('ForcedUpdateCtrl', function($rootScope, $scope, $state, $window, $ionicScrollDelegate, Registration) {
	$scope.isProcessing = false;
	$scope.errors = {message: []};
	$scope.error_present = false;

	$scope.user = {
    first_name: !$window.localStorage.getItem("first_name") ? "" : $window.localStorage.getItem("first_name"),
    last_name: !$window.localStorage.getItem("last_name") ? "" : $window.localStorage.getItem("last_name"),
    gender: $window.localStorage.getItem("gender"),
    interested_in: $window.localStorage.getItem("interested_in")
  };
	$scope.update = function(user){
						if (user.first_name == '' ){
							$scope.error_present = true;
							$scope.errors.message.push("Please enter your first name")
						}
						if (user.last_name == '' ){
							$scope.error_present = true;
							$scope.errors.message.push("Please enter your last name")
						}
						if (user.gender == '' ){
							$scope.error_present = true;
							$scope.errors.message.push("Please enter your gender")
						}
            if (user.interested_in == '' ){
              $scope.error_present = true;
              $scope.errors.message.push("Please enter what sex you interested in")
            }
						else {
							$scope.isProcessing = true;
							Registration.update(user)
								.then(function(send_push_permission){
			        				if (send_push_permission == null || $window.localStorage.getItem("asked_permission") != 'true'){
										$scope.isProcessing = false;
										$rootScope.apply;
										$state.go('permission_for_alerts')
									}
									else {
										$scope.isProcessing = false;
										$rootScope.apply;
										$state.go("loading")
									}
								}, function(reject_message){
								$scope.error_present = true;
								for (var prop in reject_message) {
									$scope.errors.message.push("this " + prop + " " + reject_message[prop])
								}
								$scope.isProcessing = false;
							})
						}
					}
})

.controller('ChatsCtrl', function($scope, $window, $state, $ionicPopup, $ionicScrollDelegate, $ionicViewSwitcher, $ionicModal, Chat, User, Loader, MyPusher, Banner, Purchase, $ionicTabsDelegate) {
	$scope.chats = Chat;
	$scope.purchase = Purchase;
  $scope.isIOS = ionic.Platform.isIOS();
  $scope.isAndroid = ionic.Platform.isAndroid();
	var page = 1;
  $scope.isPremium = $window.localStorage.getItem("is_premium") == 'true' ? true : false;

	$scope.doRefresh = function(){
							Loader.show_loading();
						    Chat.fetch_index(1)
								.then(function(response){
									User.add_others_not_in_meet(response)
										.then(function(){
											Loader.remove_loading();
											$scope.$broadcast('scroll.refreshComplete');
										},
										function(){
											Loader.remove_loading();
											$scope.$broadcast('scroll.refreshComplete');
										})
								}, function(){})
						}
	$scope.goToRequest = function(id){
							$state.go('tabs.request', {id: id})
						}
	$scope.$on("$ionicView.beforeEnter", function () {
    $ionicTabsDelegate.showBar(true);
		$ionicScrollDelegate.scrollTo(0, 0, false);
		$scope.ads = {show_ads: ($window.localStorage.getItem("show_ads") == 'true' ? true : false)};
    $scope.isPremium = $window.localStorage.getItem("is_premium") == 'true' ? true : false;
	});

	// reconnect to channel if it is not connected yet
	$scope.$on("$ionicView.afterEnter", function(event, data){
		if ($window.localStorage.getItem("is_premium") && $window.localStorage.getItem("is_premium") == 'false'){
			Banner.show();
		}
		window.ga.trackView('Chats Screen');
	});

	$scope.delete_chat = function(chat_id){
							var confirmPopup = $ionicPopup.confirm({
							     title: 'Delete this Natter',
							     template: 'Are you sure you want to delete this natter?'
							   });

							   confirmPopup.then(function(res) {
							     if(res) {
							       Chat.remove(chat_id)
							     } else {

							     }
							   });
						}

	$ionicModal.fromTemplateUrl('templates/subscription_modal.html', {
		scope: $scope,
		animation: 'slide-in-up'
		}).then(function(subscription_modal) {
			$scope.subscription_modal = subscription_modal;
		}
	);

  $scope.openSubscriptionModal = function() {
    if(!$window.localStorage.getItem("checkFree7ShownTime")){
      $window.localStorage.setItem("checkFree7ShownTime", new Date().getTime());
      $window.localStorage.setItem("prevStateFree7", 'tabs.chats');
      $state.go('free_days_view');
      return;
    }
    var pTimeFree = $window.localStorage.getItem("checkFree7ShownTime");
    if(pTimeFree){
      if(((new Date().getTime() - Number(pTimeFree)) / 3600000) > 24){
        $window.localStorage.setItem("checkFree7ShownTime", new Date().getTime());
        $window.localStorage.setItem("prevStateFree7", 'tabs.chats');
        $state.go('free_days_view');
        return;
      }
    }
    $scope.subscription_modal.show();
    Banner.hide();

  };

	$scope.closeSubscriptionModal = function() {
									Banner.show();
									$scope.subscription_modal.hide();
								};

	$ionicModal.fromTemplateUrl('templates/subscription_details_modal.html', {
		scope: $scope,
		animation: 'slide-in-up'
		}).then(function(subscription_details_modal) {
			$scope.subscription_details_modal = subscription_details_modal;
		}
	);

	$scope.openSubscriptionDetailsModal = function() {
									$scope.subscription_details_modal.show();
								}

	$scope.closeSubscriptionDetailsModal = function() {
									$scope.subscription_details_modal.hide();
								};
  //

  $ionicModal.fromTemplateUrl('templates/privacy_policy.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(privacy_policy_modal) {
      $scope.privacy_policy_modal = privacy_policy_modal;
    }
  );

  $scope.openPrivacyPolicyModal = function() {
    $scope.privacy_policy_modal.show();
  };

  $scope.closePrivacyPolicyModal = function() {
    $scope.privacy_policy_modal.hide();
  };

  $ionicModal.fromTemplateUrl('templates/terms_of_use.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(terms_of_use_modal) {
      $scope.terms_of_use_modal = terms_of_use_modal;
    }
  );

  $scope.openTermsOfUseModal = function() {
    $scope.terms_of_use_modal.show();
  };

  $scope.closeTermsOfUseModal = function() {
    $scope.terms_of_use_modal.hide();
  };


	$scope.$on('purchase_done', function(event, args) {
		$scope.ads = { show_ads: false };
    $scope.isPremium = true;
		$scope.subscription_modal.hide();
		$scope.subscription_details_modal.hide();
	});


	$scope.ad_free_subscription = function(){
									Purchase.paid()
										.then(function(){
										}, function(){})
								}
})


.controller('ChatCtrl', function($scope, $rootScope, $ionicTabsDelegate, $ionicModal, $http, $ionicViewSwitcher, $stateParams, $ionicActionSheet, $window, $cordovaCamera, $cordovaFileTransfer, $ionicScrollDelegate, $state, $timeout, App, Chat, Message, User, Typing, MyPusher, Interstitial, Banner) {
	$scope.data = {};
  	$scope.data.message = "";
  	$scope.isProcessing = false;
  	$scope.button = {blue: false};
  	$scope.new_chat = false;


  	$scope.doRefresh = function(){
  							Chat.get_historic($stateParams.other_user_id)
  								.then(function(){
		  							$scope.$broadcast('scroll.refreshComplete');
  								}, function(){
  									$scope.$broadcast('scroll.refreshComplete');
  								})
  						}

	// reconnect to channel if it is not connected yet
	$scope.$on("$ionicView.afterEnter", function(event, data){
		$ionicScrollDelegate.scrollBottom(true);
	  	window.ga.trackView('Single Chat Screen');
	});


	$scope.$on("$ionicView.beforeEnter", function () {
		$ionicTabsDelegate.showBar(false);
	});
	$scope.$on("$ionicView.beforeLeave", function () {
		$ionicTabsDelegate.showBar(true);
		$scope.focusManager.focusInputOnBlur = false;
		if ($window.localStorage.getItem("is_premium") && $window.localStorage.getItem("is_premium") == 'false'){
			Banner.show();
		}
		if ($scope.data.message.length > 0) {
			Typing.stop($stateParams.other_user_id);
		}
		if ($cordovaCamera){
			$cordovaCamera.cleanup(function(){console.log('camera cleaned up')}, function(){})
		}
	});

	$scope.$on("$ionicView.afterLeave", function () {
		Interstitial.show(4);
		//Interstitial.prepare();
	});

  	$scope.chat = null;
	Chat.find_by_id($stateParams.other_user_id)
		.then(function(chat){
			if (chat == "non_existant"){ // does not exist at all
				User.find($stateParams.other_user_id)
					.then(function(user){
						$scope.new_chat = true;
						$scope.chat = {
											other_user_id: user.id,
											other_avatar_url: user.avatar.url,
											other_user_first_name: user.first_name,
											other_user_username: user.username
										}
						$ionicScrollDelegate.scrollBottom(true);
					}, function(){})
			}
			else if (chat == "present_but_not_in_app"){ // contact server and fetch everything
				$scope.Loading = {now: true};
				Chat.fetch_whole_chat_from_server($stateParams.other_user_id)
					.then(function(chat){
						$scope.chat = chat;
						$scope.Loading = { now: false };
						$ionicScrollDelegate.scrollBottom(true);
					}, function(){})
			}
			else { // it is in the app, contact server and fetch only last 20 messages
				$scope.chat = chat
				$scope.Loading = {now: true};
				Chat.fetch_messages_for_one_chat($stateParams.other_user_id)
					.then(function(){
						$scope.Loading = {now: false};
						$ionicScrollDelegate.scrollBottom(true);
					}, function(){})
			}
		}, function(){})

	$scope.$on('newReceivedMessage', function(event) {
		$timeout(function() {
			$ionicScrollDelegate.scrollBottom(true);
			Chat.read($stateParams.other_user_id)
		}, 1000);
	});

  	// SCROLL BOTTOM IN ENTRANCE
	$scope.$on("$ionicView.afterEnter", function(event, data){
		$timeout(function() {
			// $ionicScrollDelegate.scrollBottom(true);
			Chat.read($stateParams.other_user_id)
		}, 400);
	});

	$scope.inputUp = function() {
		$timeout(function() {
			$ionicScrollDelegate.resize();
			$ionicScrollDelegate.scrollBottom(true);
		}, 600)
	}

	// TYPING
	$scope.$watch("data.message", function(newValue, oldValue){
		if (newValue.length > 0 && oldValue.length == 0) {
			$scope.button = {blue: true};
			Typing.start($stateParams.other_user_id);
		}
		else if (newValue.length == 0 && oldValue.length > 0) {
			$scope.button = {blue: false};
			Typing.stop($stateParams.other_user_id);
		}
	})

  // SEND MESSAGE
  $scope.sendMessage = function() {
    if ($scope.data.message.length > 0) {
    	var new_message = $scope.data.message
    	var rand_id = Math.random().toString(32)
    	Chat.find_by_id($stateParams.other_user_id)
			.then(function(chat){
				$scope.chat = chat;
			  if(typeof chat === 'object') {
          if (chat.messages.length > 0) {
            if (!chat.messages[chat.messages.length - 1].other) {
              chat.messages[chat.messages.length - 1].isLast = false;
            }
          }
          for (var j = 0; j < chat.messages.length; j++) {
            if (chat.messages[j].isMyLastMsg) {
              chat.messages[j].isMyLastMsg = false;
            }
          }


          chat.messages.push({id: rand_id, words: new_message, other: false, isLast: true, isMyLastMsg: true})
        }
			}, function(){});
      	Message.create($scope.data.message, null, $stateParams.other_user_id, rand_id)
			.then(function(create_or_not){
				if (create_or_not == "non_existent"){
					// the chat
					Chat.find_by_id($stateParams.other_user_id)
						.then(function(chat){
              //check all last messages for set tail
                var pMsgLength = chat.messages.length;
                for (var i=0; i < pMsgLength; i++){
                  if(chat.messages[i+1]){
                    if(chat.messages[i].other === chat.messages[i+1].other){
                      chat.messages[i].isLast = false;
                    }else {
                      chat.messages[i].isLast = true;
                    }
                  }else{
                    chat.messages[i].isLast = true;
                  }
                };
							$scope.chat = chat
						})
				}
				$rootScope.apply;
				$ionicScrollDelegate.scrollBottom(true);
			}, function(){})
		$scope.data.message = "";
		$timeout(function() {
			$ionicScrollDelegate.scrollBottom(true);
		}, 1000);
    }
  };

	$scope.focusManager = { focusInputOnBlur: true };

	$scope.shouldNotFocusOnBlur = function() {
		$scope.focusManager.focusInputOnBlur = false;
		Banner.show();
		$timeout(function() {
			$ionicScrollDelegate.resize();
			$ionicScrollDelegate.scrollBottom(true);
		}, 300)
	};

	$scope.scroll = function(){
		Banner.hide();
		$timeout(function() {
			$ionicScrollDelegate.resize();
			$ionicScrollDelegate.scrollBottom(true);
		}, 300)
	}

	$ionicModal.fromTemplateUrl('templates/image-modal.html', {
		scope: $scope,
		animation: 'slide-in-up'
		}).then(function(modalImage) {
			$scope.modalImage = modalImage;
		}
	);

	$scope.openImageModal = function(imageUrl) {
									$scope.imageUrl = imageUrl;
									$scope.modalImage.show();
									Banner.hide();
								}

	$scope.closeImageModal = function() {
									$scope.modalImage.hide();
									if ($window.localStorage.getItem("is_premium") && $window.localStorage.getItem("is_premium") == 'false'){
										Banner.show();
									}
								};

	$scope.chooseCameraType = function() {
		$ionicActionSheet.show({
			buttons: [
				{ text: 'Take a picture' },
				{ text: 'Choose from gallery' }
			],
			titleText: '',
			cancelText: 'Cancel',
			buttonClicked: function(index) {
				if (index == 0){
					take_Picture('camera');
					return true
				}
				else{
					take_Picture('gallery');
					return true
				}
			}
		});
	}

  	take_Picture = function(type){
	    if (type == 'camera') {
	      	sourceType = Camera.PictureSourceType.CAMERA
	    }
	    else {
	      	sourceType = Camera.PictureSourceType.PHOTOLIBRARY
	    }
	    var options = {
			destinationType: Camera.DestinationType.FILE_URI,
			sourceType: sourceType,
			encodingType: 1,
			cameraDirection: 1,
			quality: 100,
			targetWidth: 500,
	      	targetHeight: 500
	    };
    	$cordovaCamera.getPicture(options)
	      	.then(function(imageURI) {
	      		$scope.isProcessing = true;
		        var server = App.url + App.version + '/chat/' + $stateParams.other_user_id + '/message';
		        var filePath = imageURI;
		        var file_options = {
										"params":{
											"api_key": $window.localStorage.getItem("api_key"),
											"key": App.key,
											"to": $stateParams.other_user_id,
											"words": ""
										}
	                            	};
				$cordovaFileTransfer.upload(server, filePath, file_options)
					.then(function(result) {
						data = JSON.parse(result.response)
						Chat.add_message(data.chat.other_user_id, data.chat.id, data.chat.words, data.chat.picture, data.chat.picture_thumbnail, true, data.chat.to)
							.then(function(){
								$scope.isProcessing = false;
								$timeout(function() {
									$ionicScrollDelegate.scrollBottom(true);
								}, 1000);
							}, function(){})
					}, function(err) {});
	        }, false);
  }
})


.controller("RequestCtrl", function($scope, $stateParams, $state, Chat){
	$scope.request = {};
	// $scope.$on('$ionicView.beforeEnter', function (event, viewData) {
	//   	viewData.enableBack = true;
	// 	$rootScope.$ionicGoBack = function() {
	// 		$state.go('tabs.chats')
	// 	}
	// })
	$scope.$on("$ionicView.afterEnter", function(event, data){
		window.ga.trackView('Request Screen');
	});

	Chat.find_request($stateParams.other_user_id)
		.then(function(request){
			$scope.request = request;
		}, function(){})
	$scope.accept = function(){
		Chat.accept($stateParams.other_user_id)
			.then(function(){
				$state.go('tabs.chats')
			}, function(){})
	}
	$scope.deny = function(){
		Chat.deny($stateParams.other_user_id)
			.then(function(){
				$state.go('tabs.chats')
			}, function(){})
	}
})

.controller('InAppNotifCtrl', function($scope, $state, $ionicHistory, $ionicViewSwitcher, InAppNotifications, Loader, $window, $ionicModal, Banner, Purchase){
	$scope.notifs = InAppNotifications;
  $scope.ads = {show_ads: ($window.localStorage.getItem("show_ads") == 'true' ? true : false)};
  $scope.purchase = Purchase;
  $scope.isIOS = ionic.Platform.isIOS();
  $scope.isAndroid = ionic.Platform.isAndroid();
  $scope.isPremium = $window.localStorage.getItem("is_premium") == 'true' ? true : false;

	$scope.$on("$ionicView.afterEnter", function(event, data){
		InAppNotifications.read();
		window.ga.trackView('In App Notifications Screen');
	});

	$scope.goToNotif = function(tab_origin, type, object_id){
		if (type == 'visit') {
			tab_destination = 'tabs.profile_from_' + tab_origin
		}
		else if (type == 'comment') {
			tab_destination = 'tabs.post_from_' + tab_origin
		}
		else if (type == 'news_like') {
			tab_destination = 'tabs.post_from_' + tab_origin
		}
		else if (type == 'picture_like') {
			tab_destination = 'tabs.profile_from_' + tab_origin
		}
		$state.go(tab_destination, {id: object_id});
	};

	var pager = 1;
  $scope.moreItemsAvailable = true;
	$scope.doRefresh = function(){
							Loader.show_loading();
							InAppNotifications.get_index(1)
								.then(function(){
									Loader.remove_loading();
									$scope.$broadcast('scroll.refreshComplete');
								},
								function(){
									Loader.remove_loading();
									$scope.$broadcast('scroll.refreshComplete');
								})
						};
	$scope.loadMore = function(){

							pager = pager + 1;
							InAppNotifications.get_index(pager)
								.then(function(items){

                if(items.length === 0){
                  $scope.moreItemsAvailable = false;
                }else{
                  $scope.moreItemsAvailable = true;
                }
                  Loader.remove_loading();
									$scope.$broadcast('scroll.infiniteScrollComplete');

								}, function(){
                  Loader.remove_loading();
                  $scope.$broadcast('scroll.infiniteScrollComplete');
                })
						};

	$scope.moreNotifToLoad = function(){
    return $scope.moreItemsAvailable;
  };

  $ionicModal.fromTemplateUrl('templates/subscription_modal.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(subscription_modal) {
      $scope.subscription_modal = subscription_modal;
    }
  );

  $scope.openSubscriptionModal = function() {
    $scope.subscription_modal.show();
    Banner.hide();
  };

  $scope.closeSubscriptionModal = function() {
    Banner.show();
    $scope.subscription_modal.hide();
  };

  //

  $ionicModal.fromTemplateUrl('templates/privacy_policy.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(privacy_policy_modal) {
      $scope.privacy_policy_modal = privacy_policy_modal;
    }
  );

  $scope.openPrivacyPolicyModal = function() {
    $scope.privacy_policy_modal.show();
  };

  $scope.closePrivacyPolicyModal = function() {
    $scope.privacy_policy_modal.hide();
  };

  $ionicModal.fromTemplateUrl('templates/terms_of_use.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(terms_of_use_modal) {
      $scope.terms_of_use_modal = terms_of_use_modal;
    }
  );

  $scope.openTermsOfUseModal = function() {
    $scope.terms_of_use_modal.show();
  };

  $scope.closeTermsOfUseModal = function() {
    $scope.terms_of_use_modal.hide();
  };

  $scope.ad_free_subscription = function(){
    Purchase.paid()
      .then(function(){
      }, function(){})
  }

})

.controller('WhoCheckedMeCtrl', function($scope, $ionicViewSwitcher, InAppNotifications, Loader){
	$scope.visits = InAppNotifications;

	$scope.$on("$ionicView.afterEnter", function(event, data){
		Loader.show_loading();
		InAppNotifications.who_checked_me()
			.then(function(){
				Loader.remove_loading();
				$scope.$broadcast('scroll.refreshComplete');
			}, function(){
				Loader.remove_loading();
				$scope.$broadcast('scroll.refreshComplete');
			});
		window.ga.trackView('Who checked me Screen');
	});
	$scope.doRefresh = function(){
		InAppNotifications.who_checked_me()
			.then(function(){
				Loader.remove_loading();
				$scope.$broadcast('scroll.refreshComplete');
			}, function(){
				Loader.remove_loading();
				$scope.$broadcast('scroll.refreshComplete');
			})
	}

})

.controller('RetryLoadingCtrl', function($scope, $ionicViewSwitcher, $window, Banner){
	$scope.$on("$ionicView.afterEnter", function(event, data){
		window.ga.trackView('Retry Loading Screen');
	})

	$scope.$on("$ionicView.beforeEnter", function(event, data){
		Banner.hide();
	})
})

.controller("ForgotPasswordCtrl", function($scope, User){
	$scope.not_sent = true;
	$scope.user = {email: ""}

	$scope.resend_password = function(email){
								User.reset_password_instructions(email)
									.then(function(){
										$scope.user.email = '';
										$scope.not_sent = false;

									}, function(){
										$scope.user.email = '';
										$scope.not_sent = false;
									})
							}
})

.controller("PermissionForAlertsCtrl", function($scope, $state, $window, User, PushPermission, Geo){
	$scope.show_spinner = false;

	$scope.no_to_alert = function(){
								$scope.show_spinner = true;
								$window.localStorage.setItem("asked_permission", 'true');
								User.permit_push(false)
									.then(function(){
										$state.go('loading');
										$scope.show_spinner = false;
									}, function(){
										$state.go('loading');
										$scope.show_spinner = false;
									})
							}
	$scope.yes_to_alert = function(){
								$scope.show_spinner = true;
								$window.localStorage.setItem("asked_permission", 'true');
								User.permit_push(true)
									.then(function(){
										PushPermission.init()
											.then(function(){
												if ($window.plugins.OneSignal){
													$window.plugins.OneSignal.getIds(function(response) {
														if (!$window.localStorage.getItem("signalId")) {
															$window.localStorage.setItem("signalId", response.userId);
														}
													});
													// PUSH NOTIFICATION ENDS
												}
												$state.go('loading');
												$scope.show_spinner = false;
											}, function(){
												$state.go('loading');
												$scope.show_spinner = false;
											})
									}, function(){
										$state.go('loading');
										$scope.show_spinner = false;
									})
							}
})

.controller("SubscriptionCtrl", function($scope, $window, $state, Banner){
	$scope.subscribe = function(){
							$window.localStorage.setItem("show_ads", "false")
							Banner.hide();
							$window.location.reload(true);
						}
	$scope.unsubscribe = function(){
							$window.localStorage.setItem("show_ads", "true")
							$window.location.reload(true);
						}
})
